"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.acknowledgeMessage = void 0;
const redis_keys_1 = require("../../../common/redis-keys/redis-keys");
function acknowledgeMessage(config, redisClient, message, keyQueueProcessing, cb) {
    const queue = message.getDestinationQueue();
    const { store, queueSize, expire } = config.messages.store.acknowledged;
    if (store) {
        const { keyQueueAcknowledged } = redis_keys_1.redisKeys.getQueueKeys(queue);
        if (queueSize || expire) {
            redisClient.lpoprpushextra(keyQueueProcessing, keyQueueAcknowledged, queueSize > 0 ? queueSize * -1 : queueSize, expire, (err) => {
                if (err)
                    cb(err);
                else
                    cb();
            });
        }
        else {
            redisClient.lpoprpush(keyQueueProcessing, keyQueueAcknowledged, (err) => {
                if (err)
                    cb(err);
                else
                    cb();
            });
        }
    }
    else {
        redisClient.rpop(keyQueueProcessing, (err) => cb(err));
    }
}
exports.acknowledgeMessage = acknowledgeMessage;
//# sourceMappingURL=acknowledge-message.js.map