"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.requeueMessage = void 0;
const redis_keys_1 = require("../../../common/redis-keys/redis-keys");
const redis_smq_common_1 = require("redis-smq-common");
function requeueMessage(mixed, message, keyQueueProcessing, unacknowledgedCause, cb) {
    const queue = message.getDestinationQueue();
    const { keyRequeueMessages } = redis_keys_1.redisKeys.getQueueKeys(queue);
    if (mixed instanceof redis_smq_common_1.RedisClient) {
        if (!cb)
            throw new redis_smq_common_1.errors.PanicError(`Expected a callback function`);
        mixed.rpoplpush(keyQueueProcessing, keyRequeueMessages, (err) => cb(err));
    }
    else {
        mixed.rpoplpush(keyQueueProcessing, keyRequeueMessages);
    }
}
exports.requeueMessage = requeueMessage;
//# sourceMappingURL=requeue-message.js.map