import { QueueRateLimit } from './queue-rate-limit';
import { Namespace } from './namespace';
import { QueueMetrics } from './queue-metrics';
import { Queue } from './queue';
import { RedisClient } from 'redis-smq-common';
import { ICallback } from 'redis-smq-common/dist/types';
import { IConfig } from '../../../types';
export declare class QueueManager {
    protected readonly redisClient: RedisClient;
    readonly namespace: Namespace;
    readonly queue: Queue;
    readonly queueRateLimit: QueueRateLimit;
    readonly queueMetrics: QueueMetrics;
    protected constructor(namespace: Namespace, queue: Queue, queueRateLimit: QueueRateLimit, queueMetrics: QueueMetrics, redisClient: RedisClient);
    quit(cb: ICallback<void>): void;
    static createInstance(config: IConfig, cb: ICallback<QueueManager>): void;
}
